<?php

namespace VerifoneEcomAPI\ApiWrapper;

/**
 * Class Settings
 * @package VerifoneEcomAPI\ApiWrapper
 */
class Settings {
    const PAYMENT_TYPE_HPP = 'hpp';
    const PAYMENT_TYPE_IFRAME = 'iframe';
    const TRANSACTION_TYPE_PRE_AUTH = 'pre_auth';
    const TRANSACTION_TYPE_AUTH = 'auth';
    const TRANSACTION_TYPE_SALE = 'sale';
    const AUTH_TYPE_PRE_AUTH = 'PRE_AUTH';
    const AUTH_TYPE_FINAL_AUTH = 'FINAL_AUTH';
    const HASHED_KEY_LENGTH = 36;
    const MIN_INSTALLMENT_PAYMENT_DISPLAY_NUMBER = 2;

    private $test;
    private $region;
    private $api_user;
    private $api_key;
    private $isCardEnabled;
    private $_3ds_enable;
    private $payment_contract_id;
    private $_3ds_contract_id;
    private $entity_id;
    private $curl_verify_ssl;
    private $overlay_on_place_order;
    private $empty_on_place_order;
    private $manageOrders;
    private $authType;
    private $cvv_on_payment;
    private $complete_order_on_payment;
    private $isManualCapture;
    private $transactionType;
    private $themeId;
    private $paymentType;
    private $paypalContractId;
    private $isPaypalEnabled;
    private $isGooglePayEnabled;
    private $googlePayScaComplianceLevel;
    private $googlePayContractId;
    private $isApplePayEnabled;
    private $applePayScaComplianceLevel;
    private $applePayContractId;
    private $isSwishPayEnabled;
    private $isAbsInstallmentEnabled;
    private $abs_installment_threshholds;
    private $isMobilePayEnabled;
    private $mobilePayScaComplianceLevel;
    private $mobilePayContractId;
    private $isVippsEnabled;
    private $vippsScaComplianceLevel;
    private $vippsContractId;
    private $isKlarnaEnabled;
    private $isGpp2Enabled;
    private $gpp2ContractId;
    private $isSubscriptionEnabled;
    private $subscriptionId;
    private $isCardFraudCheckEnabled;
    private $fraudCheckContractId;
    private $isInvoice4UEnabled;
    private $invoice4UReceiptType;
    private $sendTaxRates;

    /**
     * @return mixed
     */
    public function getOverrideRedirectUrl() {
        if ( !filter_var($this->overrideRedirectUrl, FILTER_VALIDATE_URL)) {
            return null;
        }
        return $this->overrideRedirectUrl;
    }

    /**
     * @param mixed $overrideRedirectUrl
     *
     * @return Settings
     */
    public function setOoverrideRedirectUrl( $overrideRedirectUrl ) {
        $this->overrideRedirectUrl = $overrideRedirectUrl;

        return $this;
    }
    private $overrideRedirectUrl;


    /**
     * @return mixed
     */
    public function getIsCardEnabled() {
        return $this->isCardEnabled;
    }

    /**
     * @return mixed
     */
    public function getIsInvoice4UEnabled() {
        return $this->isInvoice4UEnabled;
    }
    /**
     * @return mixed
     */
    public function getSendTaxRates() {
        return $this->sendTaxRates;
    }

    /**
     * @return mixed
     */
    public function getInvoice4UReceiptType() {
        return $this->invoice4UReceiptType;
    }

    /**
     * @return mixed
     */
    public function getIsCardFraudCheckEnabled() {
        return $this->isCardFraudCheckEnabled && strlen( $this->getFraudCheckContractId() ) === self::HASHED_KEY_LENGTH;;
    }

    /**
     * @return bool
     */
    public function getIsSubscriptionEnabled() {

        return $this->isSubscriptionEnabled && strlen( $this->getSubscriptionId() ) === self::HASHED_KEY_LENGTH;
    }

    /**
     * @param bool $isSubscriptionEnabled
     *
     * @return Settings
     */
    public function setIsSubscriptionEnabled( $isSubscriptionEnabled ) {
        $this->isSubscriptionEnabled = $isSubscriptionEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getSubscriptionId() {
        return $this->subscriptionId;
    }

    /**
     * @param mixed $subscriptionId
     *
     * @return Settings
     */
    public function setSubscriptionId( $subscriptionId ) {
        $this->subscriptionId = $subscriptionId;

        return $this;
    }

    /**
     * @param bool $isCardEnabled
     *
     * @return $this
     */
    public function setIsCardEnabled( $isCardEnabled ) {
        $this->isCardEnabled = $isCardEnabled;

        return $this;
    }

    /**
     * @param bool $sendTaxRates
     *
     * @return $this
     */
    public function setSendTaxRates( $sendTaxRates ) {
        $this->sendTaxRates = $sendTaxRates;

        return $this;
    }
    /**
     * @param bool $isInvoice4UEnabled
     *
     * @return $this
     */
    public function setIsInvoice4UEnabled( $isInvoice4UEnabled ) {
        $this->isInvoice4UEnabled = $isInvoice4UEnabled;

        return $this;
    }
    /**
     * @param bool $invoice4UReceiptType
     *
     * @return $this
     */
    public function setInvoice4UReceiptType( $invoice4UReceiptType ) {
        $this->invoice4UReceiptType = $invoice4UReceiptType;

        return $this;
    }


    /**
     * @param bool $isCardFraudCheckEnabled
     *
     * @return $this
     */
    public function setIsCardFraudCheckEnabled( $isCardFraudCheckEnabled ) {
        $this->isCardFraudCheckEnabled = $isCardFraudCheckEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isMobilePayEnabled() {
        return $this->isMobilePayEnabled;
    }

    /**
     */
    public function setIsMobilePayEnabled( $isMobilePayEnabled ) {
        $this->isMobilePayEnabled = $isMobilePayEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getMobilePayScaComplianceLevel() {
        return $this->mobilePayScaComplianceLevel;
    }

    /**
     * @return mixed
     */
    public function getFraudCheckContractId() {
        return $this->fraudCheckContractId;
    }


    /**
     * @param mixed $fraudCheckContractId
     *
     * @return Settings
     */
    public function setFraudCheckContractId( $fraudCheckContractId ) {
        $this->fraudCheckContractId = $fraudCheckContractId;

        return $this;
    }

    /**
     * @param mixed $mobilePayScaComplianceLevel
     */
    public function setMobilePayScaComplianceLevel( $mobilePayScaComplianceLevel ) {
        $this->mobilePayScaComplianceLevel = $mobilePayScaComplianceLevel;

        return $this;
    }

    public function getMobilePayContractId() {
        return $this->mobilePayContractId;
    }

    /**
     * @param mixed $mobilePayContractId
     *
     * @return Settings
     */
    public function setMobilePayContractId( $mobilePayContractId ) {
        $this->mobilePayContractId = $mobilePayContractId;

        return $this;
    }


    /**
     * @return mixed
     */
    public function isSwishPayEnabled() {
        return $this->isSwishPayEnabled;
    }

    /**
     * @param mixed $swish_pay_enable
     *
     * @return Settings
     */
    public function setIsSwishPayEnabled( $swish_pay_enable ) {
        $this->isSwishPayEnabled = $swish_pay_enable;

        return $this;
    }

    /**
     * @param mixed $isGpp2Enabled
     *
     * @return Settings
     */
    public function setIsGpp2Enabled( $isGpp2Enabled ) {
        $this->isGpp2Enabled = $isGpp2Enabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getIsGpp2Enabled() {
        return $this->isGpp2Enabled && strlen( $this->getGpp2ContractId() ) === self::HASHED_KEY_LENGTH;;
    }


    /**
     * @param mixed $isKlarnaEnabled
     *
     * @return Settings
     */
    public function setIsKlarnaEnabled( $isKlarnaEnabled ) {
        $this->isKlarnaEnabled = $isKlarnaEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getIsKlarnaEnabled() {
        return $this->isKlarnaEnabled;
    }

    /**
     * @return mixed
     */
    public function isPaypalEnabled() {
        return $this->isPaypalEnabled && strlen( $this->getPaypalContractId() ) === self::HASHED_KEY_LENGTH;
    }

    /**
     * @param mixed $isPaypalEnabled
     *
     * @return Settings
     */
    public function setIsPaypalEnabled( $isPaypalEnabled ) {
        $this->isPaypalEnabled = $isPaypalEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isGooglePayEnabled() {

        return $this->isGooglePayEnabled && strlen( $this->getPaymentContractId() ) === self::HASHED_KEY_LENGTH;
    }

    /**
     * @param mixed $isGooglePayEnabled
     *
     * @return Settings
     */
    public function setIsGooglePayEnabled( $isGooglePayEnabled ) {
        $this->isGooglePayEnabled = $isGooglePayEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getGooglePayScaComplianceLevel() {
        return $this->googlePayScaComplianceLevel;
    }

    /**
     * @param mixed $googlePayScaComplianceLevel
     *
     * @return Settings
     */
    public function setGooglePayScaComplianceLevel( $googlePayScaComplianceLevel ) {
        $this->googlePayScaComplianceLevel = $googlePayScaComplianceLevel;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getGooglePayContractId() {
        return $this->googlePayContractId;
    }

    /**
     * @param mixed $googlePayContractId
     *
     * @return Settings
     */
    public function setGooglePayContractId( $googlePayContractId ) {
        $this->googlePayContractId = $googlePayContractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isApplePayEnabled() {
        return $this->isApplePayEnabled && strlen( $this->getApplePayContractId() ) === self::HASHED_KEY_LENGTH;
    }

    /**
     * @param mixed $isApplePayEnabled
     *
     * @return Settings
     */
    public function setIsApplePayEnabled( $isApplePayEnabled ) {
        $this->isApplePayEnabled = $isApplePayEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getApplePayScaComplianceLevel() {
        return $this->applePayScaComplianceLevel;
    }

    /**
     * @param mixed $applePayScaComplianceLevel
     *
     * @return Settings
     */
    public function setApplePayScaComplianceLevel( $applePayScaComplianceLevel ) {
        $this->applePayScaComplianceLevel = $applePayScaComplianceLevel;

        return $this;
    }


    /**
     * @return mixed
     */
    public function setGpp2ContractId( $gpp2ContractId ) {
        $this->gpp2ContractId = $gpp2ContractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getGpp2ContractId() {
        return $this->gpp2ContractId;
    }

    /**
     * @return mixed
     */
    public function getPaypalContractId() {
        return $this->paypalContractId;
    }

    /**
     * @param mixed $paypalContractId
     *
     * @return Settings
     */
    public function setPaypalContractId( $paypalContractId ) {
        $this->paypalContractId = $paypalContractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getApplePayContractId() {
        return $this->applePayContractId;
    }

    /**
     * @param mixed $applePayContractId
     *
     * @return Settings
     */
    public function setApplePayContractId( $applePayContractId ) {
        $this->applePayContractId = $applePayContractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isVippsEnabled() {
        return $this->isVippsEnabled;
    }

    /**
     * @param mixed $vippsEnabled
     *
     * @return Settings
     */
    public function setIsVippsEnabled( $vippsEnabled ) {
        $this->isVippsEnabled = $vippsEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getVippsScaComplianceLevel() {
        return $this->vippsScaComplianceLevel;
    }

    /**
     * @param mixed $vippsScaComplianceLevel
     *
     * @return Settings
     */
    public function setVippsScaComplianceLevel( $vippsScaComplianceLevel ) {
        $this->vippsScaComplianceLevel = $vippsScaComplianceLevel;

        return $this;
    }

    public function getVippsContractId() {
        return $this->vippsContractId;
    }

    /**
     * @param mixed $vippsContractId
     *
     * @return Settings
     */
    public function setVippsContractId( $vippsContractId ) {
        $this->vippsContractId = $vippsContractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getPaymentType() {
        return $this->paymentType;
    }

    /**
     * @param mixed $paymentType
     *
     * @return Settings
     */
    public function setPaymentType( $paymentType ) {
        $this->paymentType = $paymentType;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isManualCapture() {
        return $this->isManualCapture;
    }

    /**
     * @param mixed $isManualCapture
     *
     * @return Settings
     */
    public function setManualCapture( $isManualCapture ) {
        $this->isManualCapture = $isManualCapture;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getTransactionType() {
        return $this->transactionType;
    }

    /**
     * @param mixed $transactionType
     *
     * @return Settings
     */
    public function setTransactionType( $transactionType ) {
        $this->transactionType = $transactionType;

        switch ( $transactionType ) {
            case self::TRANSACTION_TYPE_PRE_AUTH:
                $this->setAuthType( true );
                $this->setManualCapture( true );
                break;
            case self::TRANSACTION_TYPE_AUTH:
                $this->setAuthType( false );
                $this->setManualCapture( true );
                break;
            case self::TRANSACTION_TYPE_SALE:
            default:
                $this->setAuthType( false );
                $this->setManualCapture( false );
                break;
        }

        return $this;
    }

    /**
     * @return mixed
     */
    public function getThemeId() {
        return $this->themeId;
    }

    /**
     * @param mixed $themeId
     *
     * @return Settings
     */
    public function setThemeId( $themeId ) {
        $this->themeId = $themeId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getAuthType() {
        return $this->authType;
    }

    /**
     * default value must be 'FINAL_AUTH'
     *
     * @param mixed $isPreAuth
     *
     * @return $this
     */
    public function setAuthType( $isPreAuth ) {
        $this->authType = $isPreAuth ? self::AUTH_TYPE_PRE_AUTH : self::AUTH_TYPE_FINAL_AUTH;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getCvvOnPayment() {
        return $this->cvv_on_payment;
    }

    /**
     * @param mixed $cvv_on_payment
     *
     * @return $this
     */
    public function setCvvOnPayment( $cvv_on_payment ) {
        $this->cvv_on_payment = $cvv_on_payment;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getOverlayOnPlaceOrder() {
        return $this->overlay_on_place_order;
    }

    /**
     * @param mixed $overlay_on_place_order
     *
     * @return $this
     */
    public function setOverlayOnPlaceOrder( $overlay_on_place_order ) {
        $this->overlay_on_place_order = $overlay_on_place_order;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getEmptyOnPlaceOrder() {
        return $this->empty_on_place_order;
    }

    /**
     * @return mixed
     */
    public function getManageOrders() {
        return $this->manageOrders;
    }

    /**
     * @param mixed $empty_on_place_order
     *
     * @return $this
     */
    public function setEmptyOnPlaceOrder( $empty_on_place_order ) {
        $this->empty_on_place_order = $empty_on_place_order;

        return $this;
    }
    /**
     * @param mixed $manageOrders
     *
     * @return $this
     */
    public function setManageOrders( $manageOrders ) {
        $this->manageOrders = $manageOrders;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getCurlVerifySsl() {
        return $this->curl_verify_ssl;
    }

    /**
     * @param mixed $curl_verify_ssl
     *
     * @return $this
     */
    public function setCurlVerifySsl( $curl_verify_ssl ) {
        $this->curl_verify_ssl = $curl_verify_ssl;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getEntityId() {
        return $this->entity_id;
    }

    /**
     * @param mixed $entity_id
     *
     * @return $this
     */
    public function setEntityId( $entity_id ) {
        $this->entity_id = $entity_id;

        return $this;
    }

    /**
     * @return mixed
     */
    public function get3dsContractId() {
        return $this->_3ds_contract_id;
    }

    /**
     * @param $contractId
     *
     * @return $this
     */
    public function set3dsContractId( $contractId ) {
        $this->_3ds_contract_id = $contractId;

        return $this;
    }

    /**
     * @return mixed
     */
    public function isTest() {
        return $this->test;
    }

    /**
     * @return mixed
     */
    public function getRegion() {
        return $this->region;
    }

    /**
     * @return mixed
     */
    public function getApiUserId() {
        return $this->api_user;
    }

    /**
     * @return mixed
     */
    public function getApiKey() {
        return $this->api_key;
    }

    /**
     * @return mixed
     */
    public function is3dsEnabled() {
        return $this->_3ds_enable;
    }

    /**
     * @return mixed
     */
    public function getPaymentContractId() {
        return $this->payment_contract_id;
    }

    /**
     * @return mixed
     */
    public function getCompleteOrderOnPayment() {
        return $this->complete_order_on_payment;
    }

    /**
     * @return mixed
     */
    public function getAbsInstallmentThreshholds() {
        return $this->abs_installment_threshholds;
    }

    /**
     * @return mixed
     */
    public function isAbsInstallmentEnabled() {
        return $this->isAbsInstallmentEnabled;
    }

    /**
     * @param mixed $test
     *
     * @return $this
     */
    public function setTest( $test ) {
        $this->test = $test;

        return $this;
    }

    /**
     * @param mixed $region
     *
     * @return $this
     */
    public function setRegion( $region ) {
        $this->region = $region;

        return $this;
    }

    /**
     * @param mixed $api_user
     *
     * @return $this
     */
    public function setApiUserId( $api_user ) {
        $this->api_user = $api_user;

        return $this;
    }

    /**
     * @param mixed $api_key
     *
     * @return $this
     */
    public function setApiKey( $api_key ) {
        $this->api_key = $api_key;

        return $this;
    }

    /**
     * @param $_3ds
     *
     * @return $this
     */
    public function set3dsEnable( $_3ds ) {
        $this->_3ds_enable = $_3ds;

        return $this;
    }

    /**
     * @param mixed $payment_contract_id
     *
     * @return $this
     */
    public function setPaymentContractId( $payment_contract_id ) {
        $this->payment_contract_id = $payment_contract_id;

        return $this;
    }

    /**
     * @param $complete_order_on_payment
     *
     * @return $this
     */
    public function setCompleteOrderOnPayment( $complete_order_on_payment ) {
        $this->complete_order_on_payment = $complete_order_on_payment;

        return $this;
    }

    /**
     * @param mixed $payment_contract_id
     *
     * @return $this
     */
    public function setAbsInstallmentThreshholds( $abs_installment_threshholds ) {
        $this->abs_installment_threshholds = $abs_installment_threshholds;

        return $this;
    }

    /**
     * @param $isAbsInstallmentEnabled
     *
     * @return $this
     */
    public function setIsAbsInstallmentEnabled( $isAbsInstallmentEnabled ) {
        $this->isAbsInstallmentEnabled = $isAbsInstallmentEnabled;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getAbsInstallmentThreshholdForAmount( $amount ) {
        $threshholds_string = $this->getAbsInstallmentThreshholds();
        $threshholds_array  = json_decode( $threshholds_string, true );
        foreach ( $threshholds_array as $key => $threshhold_array ) {
            if ( $key == 0 && $amount >= floatval( $threshhold_array['min_amount'] ) && $amount <= floatval( $threshhold_array['max_amount'] ) ) {
                return abs( $threshhold_array['installments'] );
            } elseif ( $amount > floatval( $threshhold_array['min_amount'] ) && $amount <= floatval( $threshhold_array['max_amount'] ) ) {
                return abs( $threshhold_array['installments'] );
            }
        }

        return null;
    }
}