var place_order_button = document.getElementById("place_order").textContent;

function verifoneIframePay() {
    if (jQuery("#payment_method_verifone_hosted_cart").is(':checked')) {
        jQuery('#tco_inline_error').html('');
        jQuery('#place_order').attr('disabled', true);
        jQuery('#place_order').html(place_order_button);

        var appendTo = jQuery('.wc_payment_method .payment_method_verifone_hosted_cart');
        if (jQuery('#payment_processing_loader').length) {
            jQuery('#payment_processing_loader').remove();
        }

        jQuery('<div id="payment_processing_loader">Creating the checkout, please wait...</div>').appendTo(appendTo);

        var tco_ajax_url;
        var tco_data;
        if (jQuery('.checkout.woocommerce-checkout').length) {
            tco_ajax_url = wc_checkout_params.checkout_url;
            tco_data = jQuery('.checkout.woocommerce-checkout').serialize();
        } else if (jQuery('form#order_review').length) {
            tco_ajax_url = wc_checkout_params.wc_ajax_url
                .toString()
                .replace('wc-ajax', 'wc-api')
                .replace('%%endpoint%%', 'verifone_iframe_handle_payment_request');
            tco_data = jQuery('form#order_review').serialize();
        }
        jQuery.ajax({
            type: 'POST',
            data: tco_data,
            url: tco_ajax_url,
            success: function (response) {
                if (response.result === "success") {
                    if (typeof response.payload !== "undefined") {
                        var payload = JSON.parse(response.payload);
                        if (jQuery('#payment_form_container').length) {
                            jQuery('#payment_form_container').remove();
                        }

                        if (jQuery('#payment_processing_loader').length) {
                            jQuery('#payment_processing_loader').remove();
                        }

                        var appendTo = jQuery('.wc_payment_method .payment_method_verifone_hosted_cart');

                        jQuery('<div id="payment_form_container"></div>').appendTo(appendTo);

                        function loadIframe(src, containerId) {
                            var script = document.createElement('script');
                            script.src = src;
                            script.async = true;
                            document.getElementById(containerId).append(script);
                        }

                        loadIframe(
                            payload.url,
                            'payment_form_container'
                        );
                        removeIframeBorder();
                    } else if (typeof response.redirect !== "undefined") {
                        window.location.href = response.redirect;
                    }
                }
                if (response.result === "failure") {
                    if (response.step !== "undefined") {
                        var notice_wrapper = jQuery('.woocommerce-notices-wrapper').first();
                        notice_wrapper.empty();
                        notice_wrapper.append('<ul class="woocommerce-error" role="alert"><li>' + response.messages + '</li> </ul>');
                        jQuery("html, body").animate({scrollTop: 0}, 1500);
                    } else {
                        jQuery('#tco_inline_error').html(response.messages);
                        jQuery('#place_order').attr('disabled', false);
                    }
                }
            },
            error: function (response, data) {
                console.error("Error response: " + response + " && data: " + data);
                jQuery('#place_order').attr('disabled', false);
                return false;
            },
            complete: function (xhr, status) {
                jQuery('#place_order').attr('disabled', false);
            }
        });
    } else {
        if (jQuery('.checkout.woocommerce-checkout').length) {
            jQuery("form.woocommerce-checkout").unbind('submit').submit();
        } else if (jQuery('form#order_review').length) {
            jQuery('form#order_review').unbind('submit').submit();
        }
    }
}

function prepareVerifoneIframe(e) {
    if (jQuery("#payment_method_verifone_hosted_cart").is(':checked')) {
        e.preventDefault();
        e.stopPropagation();
        verifoneIframePay();
        return false;
    } else {
        jQuery("form.woocommerce-checkout").off('submit', prepareVerifoneIframe);
        jQuery("form#order_review").off('submit', prepareVerifoneIframe);
        return true;
    }
}

jQuery(document).on("change", "form[name='checkout'] input[name='payment_method']", function () {
    place_order_button = document.getElementById("place_order").textContent;
    if (jQuery(this).attr('id') == 'payment_method_verifone_hosted_cart') {
        jQuery("form.woocommerce-checkout").unbind('submit');
        jQuery("form.woocommerce-checkout").on('submit', prepareVerifoneIframe);
    } else {
        jQuery("form.woocommerce-checkout").off('submit', prepareVerifoneIframe);
    }
});

jQuery(document).on("change", "form[id='order_review'] input[name='payment_method']", function () {
    place_order_button = document.getElementById("place_order").textContent;
    if (jQuery(this).attr('id') == 'payment_method_verifone_hosted_cart') {
        jQuery("form#order_review").unbind('submit');
        jQuery("form#order_review").on('submit', prepareVerifoneIframe);
    } else {
        jQuery("form#order_review").off('submit', prepareVerifoneIframe);
    }
});

jQuery(window).on('load', function () {
    if (jQuery('form.woocommerce-checkout').length) {
        jQuery(document.body).on('updated_checkout', function () {
            jQuery("form.woocommerce-checkout").unbind('submit');
            jQuery("form.woocommerce-checkout").on('submit', prepareVerifoneIframe);
        });
    } else if (jQuery('form#add_payment_method').length || jQuery('form#order_review').length) {
        jQuery("form#order_review").unbind('submit');
        jQuery("form#order_review").on('submit', prepareVerifoneIframe);
    }
});

function removeIframeBorder() {
    var iframe = jQuery('#payment_form_container').find('iframe');
    if (iframe.length) {
        iframe.css({'border': 'none'});
        return;
    } else {
        setTimeout(removeIframeBorder, 150)
    }
}

