    <!--        here we can make a full or partial amount, also can add a note on the capture action-->
    <button type="button" id="openModal" class="button" style="float: left">Capture Charge</button>
    <div id="verifoneModal">
        <table class="w100">
            <tr>
                <td class="label">Authorization total:</td>
                <td class="total"><?php echo wc_price( $order->get_total(), array( 'currency' => $order->get_currency() ) ); ?></td>
            </tr>
            <tr>
                <td class="label">Amount to be captured:</td>
                <td class="total">
                    <input type="number" step="0.1" max="<?php echo $order->get_total(); ?>" min="0.1" class="text" id="capture_amount" name="capture_amount"
                           value="<?php echo $order->get_total(); ?>"/>
                    <div class="clear"></div>
                </td>
            </tr>
            <tr>
                <td class="label">Reason <small>(optional)</small>:</td>
                <td class="total">
                    <input type="text" class="text" id="capture_reason" name="capture_reason"/>
                    <div class="clear"></div>
                </td>
            </tr>
        </table>
        <p>
            <small class="red-text">*NOTE - You can only capture an amount between
                <?php echo wc_price( 0.01, array( 'currency' => $order->get_currency() ) ); ?> and
                <?php echo wc_price( $order->get_total(), array( 'currency' => $order->get_currency() ) ); ?>.
            </small>
        </p>
        <hr class="clear"/>
        <div class="processing-vf">
            Processing, please wait...
        </div>
        <div class="buttons-vf">
            <button type="button" id="captureAmount" class="button button-primary" data-url="<?php echo $url; ?>" data-id="<?php echo $order->get_id(); ?>">Capture amount</button>
            <button type="button" id="closeModal" class="button">Cancel</button>
        </div>
    </div>
    <script type="text/javascript">
        //open modal
        jQuery('body').on('click', '#openModal', function (e) {
            jQuery('body').append('<div id="verifoneOverlay"></div>');
            jQuery('#verifoneModal').show();
        })

        //close the modal & overlay
        jQuery('body').on('click', '#verifoneOverlay, #closeModal', function (e) {
            jQuery('#verifoneOverlay').remove();
            jQuery('#verifoneModal').hide();
            jQuery('#capture_amount').val('');
            jQuery('#capture_reason').val('');
            jQuery('.vf-error').remove();
        })

        Number.prototype.countDecimals = function () {
            if (Math.floor(this.valueOf()) === this.valueOf()) return 0;
            let str = this.toString();
            if (str.indexOf(".") !== -1 && str.indexOf("-") !== -1) {
                return str.split("-")[1] || 0;
            } else if (str.indexOf(".") !== -1) {
                return str.split(".")[1].length || 0;
            }
            return str.split("-")[1] || 0;
        }

        //capture event
        jQuery('#captureAmount').click(function (e) {
            e.preventDefault();
            let amount = parseFloat(jQuery('#capture_amount').val()),
                max_amount = parseFloat(jQuery('#capture_amount').attr('max')),
                reason = jQuery('#capture_reason').val();
            if ( isNaN( amount ) ) {
                jQuery('#verifoneModal').prepend('<p class="vf-error">The capture amount must be a number!</p>')
            } else if ( amount <= 0 ) {
                jQuery('#verifoneModal').prepend('<p class="vf-error">The capture amount must be more than 0!</p>')
            } else if ( amount > max_amount ) {
                jQuery('#verifoneModal').prepend('<p class="vf-error">The capture amount cannot be more than the order total!</p>')
            } else if ( parseInt( amount.countDecimals() ) > 2 ) {
                jQuery('#verifoneModal').prepend('<p class="vf-error">The decimal of the capture amount is limited to 2 digits!</p>')
            } else {
                performCapture(jQuery(this), amount, reason);
            }
        })
    </script>
    <style>
        .red-text {
            color: red;
        }

        .vf-error {
            background: #d73131d4;
            padding: 3px 10px;
            color: #fff;
            line-height: 2em;
            border-radius: 3px
        }

        .w100 {
            width: 100%;
        }

        #verifoneModal input {
            font-weight: normal;
        }

        #verifoneModal tr td {
            line-height: 35px;
        }

        #capture_amount {
            text-align: right;
        }

        #verifoneModal .total {
            font-weight: bold;
            text-align: right;
        }

        #verifoneModal button {
            float: right;
            margin-left: .25em;
        }

        .processing-vf {
            display: none;
        }

        #verifoneModal hr {
            margin-bottom: 15px;
            margin-top: 15px;
        }

        #verifoneModal {
            display: none;
            z-index: 100;
            position: fixed;
            border: 1px solid #ddd;
            left: calc(50% - 200px);
            text-align: left;
            top: 200px;
            background: #fff;
            padding: 20px;
            border-radius: 5px;
            width: 400px;
            box-shadow: 3px 5px 4px #a8a0a0;
        }

        #verifoneOverlay {
            left: 0;
            right: 0;
            top: 0;
            z-index: 90;
            bottom: 0;
            position: fixed;
            height: 100%;
            background: rgba(102, 102, 102, 0.42);
        }
    </style>

<script type="text/javascript">

    //capture event for full amount
    jQuery('#captureFullAmount').click(function (e) {
        e.preventDefault();
        performCapture(jQuery(this));
    })

    function performCapture(self, amount, reason) {
        let postData = {},
            url = self.data('url');

        jQuery('.processing-vf').show();
        jQuery('.buttons-vf').hide();
        self.attr('disabled', true);

        postData.amount = amount || null;
        postData.reason = reason || null;
        postData.order_id = self.data('id');

        jQuery.ajax({
            method: "POST",
            url: url,
            data: postData,
        }).done(function (response) {
            alert(response.message);
            location.reload();
        }).fail(function (response) {
            console.error(response);
            jQuery('.processing-vf').hide();
            jQuery('.buttons-vf').show();
            self.attr('disabled', false);
            alert(response.message);
        })
        return true;
    }
</script>
