<?php
/**
 * Plugin Name: Verifone Hosted Cart
 * Plugin URI:
 * Description: Allows you to use Verifone Hosted payment gateway with the WooCommerce plugin.
 * Version: 2.8.0
 * Author: verifone
 * Author URI: https://www.verifone.com
 * WC requires at least: 4.6.2
 * WC tested up to: 6.4.1
 */

if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
add_filter( 'woocommerce_payment_gateways', 'add_verifone_hosted_gateway' );
function add_verifone_hosted_gateway( $methods ) {
    require_once 'autoload.php';
    require_once 'bootstrap.php';
    $methods[] = 'WC_Verifone_Hosted_Gateway';

    return $methods;
}

//for invoice4u we need to break the line items into 1 item per line item
if ( !empty(get_option( 'woocommerce_verifone_hosted_cart_settings' )['invoice4u_enabled'])
     && get_option( 'woocommerce_verifone_hosted_cart_settings' )['invoice4u_enabled'] === 'yes'
     && get_option( 'woocommerce_verifone_hosted_cart_settings' )['card_enabled'] === 'yes') {

    add_filter( 'woocommerce_add_cart_item_data', 'verifone_split_product_individual_cart_items', 10, 2 );
    add_filter( 'woocommerce_is_sold_individually', '__return_true' );
}
function verifone_split_product_individual_cart_items( $cart_item_data, $product_id ) {

    $cart_item_data['unique_key'] = uniqid();

    return $cart_item_data;
}
